package org.fluttercode.demo.conversationdemo;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.Conversation;
import javax.enterprise.context.ConversationScoped;
import javax.enterprise.inject.Produces;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

@Named("bean")
@ConversationScoped
public class BackingBean implements Serializable {

	private Long value = new Long(0);

	@Inject
	private Conversation conversation;
	
	@Inject
	private WorkspaceBean workspace;

	private List<Long> values = new ArrayList<Long>();

	public Long getValue() {
		return value;
	}

	public void setValue(Long value) {		
		this.value = value;
	}

	public String getMessage() {
		return "The value is : " + value;
	}
 
	public List<Long> getValues() {
		return values;
	}

	public void addToList() {
		values.add(value);
	}

	@PostConstruct
	public void postConstruct() {		
		conversation.begin();
		workspace.getConversations().add(conversation.getId());
	}
	
	public void confirm() {
		workspace.getConversations().remove(conversation.getId());
		conversation.end();
		
		try {
			FacesContext ctx = FacesContext.getCurrentInstance();
			ctx.getExternalContext().redirect("home.jsf?faces-redirect=true");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public Conversation getConversation() {
		return conversation;
	}
}
